'IEN Interpreter.bas for SmallBASIC 0.12.9 (B+=MGA) 2017-07-28 new name

memsize = 20000
DIM memory(memsize)
numChars = "-.1234567890"
cmdChars = "WC?ABZMIENP[X]F%^/*~+=<>()!&|"
allChars = numChars + cmdChars

while 1
  color 0, 11 : cls
  anyfile = files("IEN*.txt")
  sort anyfile
  ? "EIN (Everything Is Numbered) Files:":?
  if len(anyfile) > 0 then
    for i = 0 to ubound(anyfile)
      ? i, anyfile(i)
    next
    ? : input "Enter file NUMBER (any else quits) >  ", flnm
    if isnumber(flnm) then
      if flnm >= 0 and flmn <=ubound(anyfile) then
        getfile = anyfile(flnm)
        tload getfile, source, 1
      else
        stop
      end if
    else
      stop
    end if
  else
    ? "No files found" : source = ""
  end if
  color 7, 1 : cls
  if source <> "" then
    for i = 1 to len(source)
      ? mid(source, i, 1);
      if i mod 60 = 0 then ?
    next
    ?
  end if
  ?:input "n(New)  e(Edit)  r(Run)  k(Kill)  q(Quits)  other(Files)"; menu
  select case ucase(left(menu,1))
  case "N" : input "Enter a title, for *IEN + title + DATE.TXT* format ";tl
    dt = right(date,4) + "-" + mid(date,4,2) + "-" + left(date,2)
    fname = "IEN " + tl + " " + dt + ".txt"
    OPEN fname FOR OUTPUT AS #1
    CLOSE #1
    RUN "notepad " + fname
  case "E" : run "notepad "+ getfile
  case "K" : kill getfile
  case "Q" : end
  case "R" : color 7, 0 : cls : runSource
  end select
wend

SUB runSource
  source = UCASE(source)
  'let's clean the code up, check bracket balance
  bktCnt = 0 : ifCnt = 0 : code = ""
  FOR i = 1 TO len(source)
    char = MID(source, i, 1)
    'check to see if this is a valid instruction character
    IF INSTR(allChars, char) THEN
      code = code + char
      'count brackets
      IF char = "[" THEN bktCnt = bktCnt + 1
      IF char = "]" THEN bktCnt = bktCnt - 1
      if char = "I" Then ifCnt = ifCnt + 1
      if char = "N" then ifCnt = ifCnt - 1
    END IF
  NEXT
  IF bktCnt THEN 'mismatched brackets
    ? "Uneven brackets" : PAUSE : EXIT SUB
  ELSEIF ifCnt THEN
    ? "Uneven I N counts" : PAUSE : EXIT SUB
  ELSE
    ? code  'check
  END IF
  ERASE memory
  DIM memory(memsize)
  cmd = "" : ds = "" : err = ""
  FOR i = 1 TO LEN(code) 'loop through the code
    c = MID(code, i, 1) 'get the instruction we're on
    IF INSTR("-.1234567890", c) THEN ds = ds + c
    IF INSTR(cmdChars, c) OR i = len(code) THEN 'hit next command or end
      IF cmd <> "" THEN 'execute unfinished command
        d = VAL(ds)
        'exec last cmd
        SELECT CASE cmd
        CASE "A" : memory(1) = memory(d)
        CASE "B" : memory(2) = memory(d)
        CASE "Z" : memory(0) = d
        CASE "M" : memory(d) = memory(0)
        CASE "F"
          SELECT CASE memory(1)
          CASE 0 : if memory(2) <> 0 then memory(d) = 0 else memory(d) = 1 
          CASE 1 : memory(d) = RND
          CASE 2 : memory(d) = INT(memory(2))
          END SELECT
        CASE "W" : ? memory(d);
        case "C" : ? chr(d);
        CASE "?" : input test
          if isstring(test) then test = val(test)
          memory(d) = test
        END SELECT
        cmd = "" : ds = ""
      END IF 'if cmd <> ""

      'handle current cmd
      IF INSTR("WC?ABZMF", c) THEN  'get d first
        cmd = c
      ELSEIF c = "I" : IF memory(0) = 0 then Findi
          IF err <> "" THEN ? err : PAUSE : EXIT SUB
      ELSEIF c = "E" THEN
        Findi
        IF err <> "" THEN ? err : PAUSE : EXIT SUB
      ELSEIF c = "P" THEN
        ? 
      ELSEIF c = "X" THEN
        bktCnt = 1 'count the bracket we're on
        i = i + 1 'move the code pointer to the next char
        WHILE bktCnt <> 0
          'count nested loops till we find the matching one
          IF MID(code, i, 1) = "]" THEN bktCnt = bktCnt - 1
          IF MID(code, i, 1) = "[" THEN bktCnt = bktCnt + 1
          i = i + 1 'search forward
        WEND
        i = i - 1
      ELSEIF c = "]" THEN ' end a loop if loop index is 0
        bktCnt = -1'count the bracket we're on
        i = i - 1'move the code pointer back a char
        WHILE bktCnt <> 0
          'count nested loops till we fine the matching one
          IF MID(code, i, 1) = "]" THEN bktCnt = bktCnt - 1
          IF MID(code, i, 1) = "[" THEN bktCnt = bktCnt + 1
          i = i - 1 'search backwards
        WEND
        i = i + 1  '<<< ??? doesn't seem to matter i+1, i-1 or nothing  
      ELSEIF c = "%" THEN : memory(0) = memory(1) % memory(2)
      ELSEIF c = "^" THEN : memory(0) = memory(1) ^ memory(2)
      ELSEIF c = "/" THEN : memory(0) = memory(1) / memory(2)
      ELSEIF c = "*" THEN : memory(0) = memory(1) * memory(2)
      ELSEIF c = "~" THEN : memory(0) = memory(1) - memory(2)
      ELSEIF c = "+" THEN : memory(0) = memory(1) + memory(2)
      ELSEIF c = "=" THEN : memory(0) = memory(1) = memory(2)
      ELSEIF c = "<" THEN : memory(0) = memory(1) < memory(2)
      ELSEIF c = ">" THEN : memory(0) = memory(1) > memory(2)
      ELSEIF c = "(" THEN : memory(0) = memory(1) <= memory(2)
      ELSEIF c = ")" THEN : memory(0) = memory(1) >= memory(2)
      ELSEIF c = "!" THEN : memory(0) = memory(1) <> memory(2)
      ELSEIF c = "&" THEN : memory(0) = memory(1) and memory(2)
      ELSEIF c = "|" THEN : memory(0) = memory(1) or memory(2)          
      END IF
    END IF ' ran into next command
    '? mid(code, i, 1); :input temp
  NEXT
  ?:? "Run is done, hit any..." : pause
END SUB

SUB Findi
  'code, i, err  are global
  LOCAL cnt, c1, j
  cnt = 1
  FOR j = i + 1 TO LEN(code)
    c1 = MID(code, j, 1)
    IF c1 = "N" THEN
      cnt = cnt - 1
      IF cnt = 0 THEN i = j  : EXIT SUB
    ELSEIF c1 = "I" THEN
      cnt = cnt + 1
    ELSEIF c1 = "E" and cnt = 1 THEN
      i = j  : EXIT SUB
    END IF
  NEXT
  err = "Could not find N"
END SUB